
/*
 * RouteDisplayer.java
 *
 * Created on December 8, 2008, 6:42 PM
 */

package dynamicrouting;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.net.Socket;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.TreeMap;
import java.util.Vector;

/**
 *
 * @author  Admin
 */
public class RouteDisplayer extends javax.swing.JFrame {

    /** Creates new form RouteDisplayer */
    public RouteDisplayer() 
    {
        initComponents();
        setVisible(true);
        int w = 410;
        int h = 310;
        setSize(w, h);
        Toolkit tk = Toolkit.getDefaultToolkit();
        Dimension screenSize = tk.getScreenSize();

        int screenHeight = screenSize.height;
        int screenWidth = screenSize.width;
        //setSize(screenWidth / 2, screenHeight / 2);
        setLocation((screenWidth-w) / 2, (screenHeight-h) / 2);
        setResizable(false);        
        
    }

    public void setContents(String[] packets)
    {
        int count = 0;
        DynamicRouteGenerator dyObj = new DynamicRouteGenerator();
        TreeMap<Integer , String> tempPacketMap = null;
        String firstNode;
        
        for (int i = 0; i < packets.length; i++) 
        {            
            String string = packets[i];            
            if(i == 0)
            {
                firstNode = dyObj.getNode(StaticClass.getMyName());
                txtARoute.setText("\nPacket Number " + (i+1) + ": " + firstNode);
                System.out.println("\nPacket Number " + (i+1) + ": " + firstNode);

                /////// Insetrting the values in the TreeMap<<<< NodeName > , < Packet Content >>>> ///////
                tempPacketMap = StaticClass.getPacketMap();
                tempPacketMap.put(i, firstNode);
                StaticClass.setPacketMap(tempPacketMap);
                /////// Insetrting the values in the TreeMap<<<< NodeName > , < Packet Content >>>> ///////
                
                continue;
            }
            
            firstNode = dyObj.getRandomNextNode(StaticClass.getMyName());
            txtARoute.append("\nPacket Number " + (i+1) + ": " + firstNode);
            System.out.println("\nPacket Number " + (i+1) + ": " + firstNode);
            
            /////// Insetrting the values in the TreeMap<<<< NodeName > , < Packet Content >>>> ///////
            tempPacketMap = StaticClass.getPacketMap();
            tempPacketMap.put(i, firstNode);
            StaticClass.setPacketMap(tempPacketMap);
            /////// Insetrting the values in the TreeMap<<<< NodeName > , < Packet Content >>>> ///////
            
        }
        
        tempPacketMap = StaticClass.getPacketMap();
        Set<Entry<Integer, String>> set = tempPacketMap.entrySet();
        System.out.print("\n\n Here follows the contents of Packet Map.....\n");
        for (Map.Entry<Integer, String> me : set)
        {
          System.out.print(me.getKey() + " --- : --- ");
          System.out.println(me.getValue());
        }
        
    }
    
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jScrollPane1 = new javax.swing.JScrollPane();
        txtARoute = new javax.swing.JTextArea();
        jLabel1 = new javax.swing.JLabel();
        jButton1 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        getContentPane().setLayout(null);

        txtARoute.setColumns(20);
        txtARoute.setRows(5);
        jScrollPane1.setViewportView(txtARoute);

        getContentPane().add(jScrollPane1);
        jScrollPane1.setBounds(60, 80, 280, 150);

        jLabel1.setFont(new java.awt.Font("Book Antiqua", 1, 14));
        jLabel1.setText("Packet Choosen Routes");
        getContentPane().add(jLabel1);
        jLabel1.setBounds(60, 50, 170, 17);

        jButton1.setFont(new java.awt.Font("Book Antiqua", 1, 13));
        jButton1.setText("Start Routing");
        jButton1.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton1ActionPerformed(evt);
            }
        });
        getContentPane().add(jButton1);
        jButton1.setBounds(140, 240, 120, 25);

        pack();
    }// </editor-fold>//GEN-END:initComponents

private void jButton1ActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton1ActionPerformed
// TODO add your handling code here:

    String filePackets[] = StaticClass.getPackets();
    TreeMap tempMap = StaticClass.getPacketMap();
    Set<Map.Entry<Integer, String>> set = tempMap.entrySet();
    int i = 0;

    for (Map.Entry<Integer, String> me : set)
    {
        Vector v = new Vector();
        v.add(filePackets[me.getKey()]);
        new ServerThread().writeToClient(me.getValue(), v);      
        System.out.print(me.getKey() + ": ");
        System.out.println(me.getValue());        
    }        
}//GEN-LAST:event_jButton1ActionPerformed

    /**
    * @param args the command line arguments
    */
//    public static void main(String args[]) {
//        java.awt.EventQueue.invokeLater(new Runnable() {
//            public void run() {
//                new RouteDisplayer().setVisible(true);
//            }
//        });
//    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton1;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextArea txtARoute;
    // End of variables declaration//GEN-END:variables

}
